
/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// 声明包名
package net.micode.notes.gtask.remote;
 
// 导入所需的Android类和接口
import android.app.Notification; // 通知类
import android.app.NotificationManager; // 通知管理类
import android.app.PendingIntent; // 意图的延迟执行类
import android.content.Context; // 上下文类
import android.content.Intent; // 意图类
import android.os.AsyncTask; // 异步任务类
 
// 导入项目内部的其他类
import net.micode.notes.R; // 资源类
import net.micode.notes.ui.NotesListActivity; // 笔记列表活动
import net.micode.notes.ui.NotesPreferenceActivity; // 笔记偏好设置活动
 
// 定义一个继承自AsyncTask的类，用于执行后台任务
public class GTaskASyncTask extends AsyncTask<Void, String, Integer> {
	 // 定义通知ID
    private static int GTASK_SYNC_NOTIFICATION_ID = 5234235;
 // 定义一个接口，用于任务完成时的回调
    public interface OnCompleteListener {
        void onComplete();
    }
 // 声明成员变量
    private Context mContext; // 上下文
    private NotificationManager mNotifiManager; // 通知管理器
    private GTaskManager mTaskManager; // 任务管理器
    private OnCompleteListener mOnCompleteListener; // 任务完成监听器
 
    // 构造函数，初始化成员变量
    public GTaskASyncTask(Context context, OnCompleteListener listener) {
        mContext = context;
        mOnCompleteListener = listener;
        mNotifiManager = (NotificationManager) mContext
                .getSystemService(Context.NOTIFICATION_SERVICE);// 获取通知服务
        mTaskManager = GTaskManager.getInstance();// 获取任务管理器实例
    }
 // 取消同步的方法
    public void cancelSync() {
        mTaskManager.cancelSync();
    }
 // 发布进度的方法，注意这里重写了publishProgress方法
    public void publishProgess(String message) {
        publishProgress(new String[] {
            message
        });
    }
 // 显示通知的方法
    private void showNotification(int tickerId, String content) {
    	// 创建通知
        Notification notification = new Notification(R.drawable.notification, mContext
                .getString(tickerId), System.currentTimeMillis());
        notification.defaults = Notification.DEFAULT_LIGHTS; // 设置默认灯光
        notification.flags = Notification.FLAG_AUTO_CANCEL;// 设置自动取消
        PendingIntent pendingIntent;// 延迟意图
        // 根据tickerId判断点击通知后的跳转页面
        if (tickerId != R.string.ticker_success) {
            pendingIntent = PendingIntent.getActivity(mContext, 0, new Intent(mContext,
                    NotesPreferenceActivity.class), 0);

        } else {
            pendingIntent = PendingIntent.getActivity(mContext, 0, new Intent(mContext,
                    NotesListActivity.class), 0);
        }
     // 设置通知的详细信息
        notification.setLatestEventInfo(mContext, mContext.getString(R.string.app_name), content,
                pendingIntent);
     // 发送通知
        mNotifiManager.notify(GTASK_SYNC_NOTIFICATION_ID, notification);
    }
 // 在后台线程中执行的任务
    @Override
    protected Integer doInBackground(Void... unused) {
    	// 发布登录进度的通知
        publishProgess(mContext.getString(R.string.sync_progress_login, NotesPreferenceActivity
                .getSyncAccountName(mContext)));
     // 执行同步任务，并返回结果
        return mTaskManager.sync(mContext, this);
    }
 // 更新进度的方法
    @Override
    protected void onProgressUpdate(String... progress) {
    	// 显示同步中的通知
        showNotification(R.string.ticker_syncing, progress[0]);
     // 如果上下文是GTaskSyncService的实例，则发送广播
        if (mContext instanceof GTaskSyncService) {
            ((GTaskSyncService) mContext).sendBroadcast(progress[0]);
        }
    }
    // 任务执行完成后的方法
    @Override
    protected void onPostExecute(Integer result) {
    	// 根据结果显示不同的通知
        if (result == GTaskManager.STATE_SUCCESS) {
            showNotification(R.string.ticker_success, mContext.getString(
                    R.string.success_sync_account, mTaskManager.getSyncAccount()));
            NotesPreferenceActivity.setLastSyncTime(mContext, System.currentTimeMillis());
        } else if (result == GTaskManager.STATE_NETWORK_ERROR) {
            showNotification(R.string.ticker_fail, mContext.getString(R.string.error_sync_network));
        } else if (result == GTaskManager.STATE_INTERNAL_ERROR) {
            showNotification(R.string.ticker_fail, mContext.getString(R.string.error_sync_internal));
        } else if (result == GTaskManager.STATE_SYNC_CANCELLED) {
            showNotification(R.string.ticker_cancel, mContext
                    .getString(R.string.error_sync_cancelled));
        }
     // 如果设置了任务完成监听器，则在新线程中调用其onComplete方法
        if (mOnCompleteListener != null) {
            new Thread(new Runnable() {

                public void run() {
                    mOnCompleteListener.onComplete();
                }
            }).start();
        }
    }
}
